#ifndef common_H
#define common_H

#include<map>

using namespace std;

class Edge;
class Pin ;
class net ;
class Node;

extern net* motherNet;

// Edge, Pin, Node, char ɊւAzz (map) `A
// ꂼɖO
typedef  map< int , Edge* , less<int> > edgeMap;
typedef  map< int , Pin  * , less<int> > pinMap   ;
typedef  map< int , Node * , less<int> > nodeMap  ;
typedef  map< int , char * , less<int> > signalMap;

enum  nodeType{
                    //  logical element
                    and,        or,         not,        xor,
                    add,        inc,        multipuly,
                    rshift,     lshift,
                    multiplexer, reg, nullnode,
};

class Edge{
    Node*       dstNode ;
    Node*       srcNode ;
    Pin*        dstPin  ;
    Pin*        srcPin  ;
public:
    int         ID    ;

    // ftHgRXgN^B
    // |C^ɂ̓k|C^Aɂ 0 B
    Edge(){dstNode=srcNode=0; dstPin=srcPin=0; ID=0;}

   ~Edge(){}    // fXgN^BȂB

    friend class Node;        // Node, simulation, Pin NX
    friend class simulation;  // Edge NX private oɃANZXł
    friend class Pin ;        // (friend NX)
};

class Pin{

  public:
    int           ID          ;    // e Pin ɂ ID
    int           EIN         ;    // Pin ̒l
    int           edgeCount   ;    // Pin ɐڑꂽ edge ̐
    Node*         motherNode  ;    // Pin  Node
    edgeMap       edge        ;    //  ڑC ڑ Edge ̃Xg

    Pin(int pinID, Node* mNode): ID(pinID), EIN(2), edgeCount(0),motherNode(mNode) { }
    Pin():EIN(2),edgeCount(0){}

    // Pin  Edge o^
    void edgeAdd(Edge* edg){
      edge.insert(edgeMap::value_type( edgeCount++, edg )); 
    }
};

class net{

  private:
    int       nodeSu;  // net  Node ̐
    nodeMap   node  ;  // net ɑ Node ̘Azz

  public:

    net():nodeSu(0){}  // ftHgRXgN^

    // net  Node o^Bo^邽т nodeSu  1 ₷B
    void  addNode( Node* nodep ){
      node.insert(nodeMap::value_type( nodeSu++, nodep));
    }
};

// net NX module NXƂOŗp邽߁B
// verilog Ƃ̑Ή
class module:public net{
  public:
    module(){ motherNet = this; }
};

class Node{

  public:
    int           ID            ;     // Node  ID
    int           out           ;     //  óBl͕s (2)
    nodeType      nType         ;     // m[h̑ , and, or, etc,
    pinMap        outPin        ;     //  o̓s̃Xg
    pinMap        inPin         ;     //  ̓s̃Xg
    bool requestRun;

    static simulation* SimObj;

    Node(nodeType nodeT):ID(0), out(2),nType(nodeT), requestRun( false ){}
	

    // 2  1 o͂̏ꍇ̃RXgN^
    Node( Edge& o1, Edge& i1, Edge& i2, nodeType nodeT):out(2), requestRun( false ){

      // Pin, Edge, Node ̊֌Wo^B
      o1.srcNode = this        ;
      o1.srcPin  = outPinAdd(0);
      outPin[0]->edgeAdd(&o1)  ;

      i1.dstNode = this        ;
      i1.dstPin  = inPinAdd(0) ;
      inPin[0]->edgeAdd(&i1)   ;

      i2.dstNode = this        ;
      i2.dstPin  = inPinAdd(1) ;
      inPin[1]->edgeAdd(&i2)   ;

      nType      = nodeT       ;
      motherNet->addNode(this) ;  // net ɂ Node o^
      
    }

    // 1  1 o͂̏ꍇ̃RXgN^
    Node( Edge& o1, Edge& i1, nodeType nodeT):out(2), requestRun( false ){ 

      // Pin, Edge, Node ̊֌Wo^B	          
      o1.srcNode = this        ;
      o1.srcPin  = outPinAdd(0);
      outPin[0]->edgeAdd(&o1)  ;

      i1.dstNode = this        ;
      i1.dstPin  = inPinAdd(0) ;
      inPin[0]->edgeAdd(&i1)   ;

      nType      = nodeT       ;
      motherNet->addNode(this) ;  // net ɂ Node o^
    }

    virtual ~Node(){}   // fXgN^BȂB

    void outEdgeAdd( Edge& o1 ){
      o1.srcNode = this        ;
      o1.srcPin  = outPin[0]   ;
      outPin[0]->edgeAdd(&o1)  ;
    }

    // Node ɓ Pin o^
    Pin* inPinAdd( int pinID ){
      Pin* inPin0 = new Pin(pinID, this);
      inPin.insert(pinMap::value_type( pinID , inPin0 ));
      return inPin0; 
    }

    // Node ɏo Pin o^
    Pin* outPinAdd( int pinID ){
      Pin* outPin0 = new Pin(pinID, this);
      outPin.insert(pinMap::value_type( pinID , outPin0 )); 
      return outPin0; 
    }

    // _ȞvZ̖{ (z֐Ƃ virtual ƂL[[h)
    virtual bool exec(int time,int svalue, Pin* pin);
};

class And:public Node{
 public: 
    // And fq̃RXgN^
    And(Edge& o1, Edge& i1, Edge& i2): Node(o1,i1,i2, and){}

    // exec ֐̃I[o[Ch
    bool exec(int time,int svalue, Pin* pin);	
};

class  Or:public Node{
 public: 
    // Or fq̃RXgN^
    Or(Edge& o1, Edge& i1, Edge& i2 ):Node(o1,i1, i2, or){}

    // exec ֐̃I[o[Ch
    bool exec(int time,int svalue, Pin* pin);
};

class Not:public Node{
 public: 
    // Not fq̃RXgN^
    Not(Edge& o1, Edge& i1):Node(o1,i1,not){}

    // exec ֐̃I[o[Ch
    bool exec(int time,int svalue, Pin* pin);	
};

class NullNode:public Node{
 public: 
    // Not fq̃RXgN^
    NullNode(Edge& o1, Edge& i1):Node(o1,i1,nullnode){}

    // exec ֐̃I[o[Ch
    bool exec(int time,int svalue, Pin* pin);	
};


#endif
