#include <stack>
#include <queue>

#include "common.h"

using namespace std;

class simulation;

class event{
  public:
    unsigned int time  ;                 // Cxg
    simulation*        SimObj;

    event(unsigned int t): time(t){ }    // RXgN^
    virtual void processEvent    ()=0;   // z֐
};

struct eventComparison{
  bool operator () ( event * left, event * right){
    return left->time > right->time; 
  }
};

class execEvent : public event{
  private:
    Node* NodeObj;              // Cxg Node
    int   svalue;               // Cxgɂē`l
    Pin*  pin;                  // CxgB Pin

  public:
   // RXgN^
   execEvent( unsigned int time, int svlin , Pin* inpin, Node* destNode )
    : event(time), NodeObj(destNode), svalue(svlin), pin(inpin) {}

   void processEvent();   // Cxg̏
};

class deliverEvent : public event{

  private:
    Node* NodeObj;              // Cxg Node

  public:
   deliverEvent( unsigned int time, Node* destNode )
    : event(time), NodeObj(destNode){}

   void processEvent();   // Cxg֓`
};

class simulation {
 protected:
  //D揇ʃL[̐錾
  priority_queue <event *, vector<event *>, eventComparison > eventQueue;

 public:
  unsigned int  time;
  unsigned int eventID;     // CxgɊ蓖Ă ID
  simulation* SimObj;

  // RXgN^
  simulation () : eventQueue(),time(0) ,eventID(0) { SimObj = this;}

  // Cxg̃Zbg
  void scheduleEvent (event * newEvent);
  void set(int time, int value, Edge& s){ 
    scheduleEvent(new execEvent(time, value, s.dstPin, s.dstNode)); 
  }
  
  // eɂ_ľvZ
  void run(unsigned int);

  // ʂ̓`
  void deliver(unsigned int t, Node* nobj);
};
